//+------------------------------------------------------------------+
//|                                                        Bands.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  LightSeaGreen
#property indicator_color2  LightSeaGreen
#property indicator_color3  LightSeaGreen

//
//
//
//
//

extern string TimeFrame              = "current time frame";
extern int    BandsLength            = 20;
extern double BandsDeviation         = 2.0; 
extern int    AppliedPrice           = PRICE_CLOSE;
extern int    BandsMaMode            = MODE_SMA; 

extern bool   alertsOn               = true;
extern bool   alertsOnHiLoCross      = true;
extern bool   alertsOnCloseCross     = false;
extern bool   alertsOnOpenCloseCross = true;
extern bool   alertsOnCurrent        = false;
extern bool   alertsMessage          = true;
extern bool   alertsSound            = false;
extern bool   alertsNotify           = true;
extern bool   alertsEmail            = true;
extern string soundFile              = "alert2.wav"; 

//
//
//
//
//

double Ma[];
double UpMa[];
double DnMa[];
double trend1[];
double trend2[];
double trend3[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
  IndicatorBuffers(6);
   SetIndexBuffer(0,Ma);
   SetIndexBuffer(1,UpMa);
   SetIndexBuffer(2,DnMa);
   SetIndexBuffer(3,trend1);
   SetIndexBuffer(4,trend2);
   SetIndexBuffer(5,trend3);

      //
      //
      //
      //
      //
   
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame=="returnBars";     if (returnBars)     return(0);
      calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
  IndicatorShortName(timeFrameToString(timeFrame)+"   bollinger bands ");    
return(0);
}

int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
  {
   int counted_bars=IndicatorCounted();
   int i,j,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-1,Bars-counted_bars-1);
           if (returnBars)  { Ma[0] = limit+1; return(0); }
           
   //
   //
   //
   //
   //
    
   if (calculateValue || timeFrame==Period())
   {       
     for (i = limit; i >= 0; i--)
     {
         double StdDev  = iStdDev(NULL,0,BandsLength,0,BandsMaMode,AppliedPrice,i); 
                Ma[i]   = iMA(NULL,0,BandsLength,0,BandsMaMode,AppliedPrice,i);
                UpMa[i] = Ma[i] + (StdDev*BandsDeviation);
                DnMa[i] = Ma[i] - (StdDev*BandsDeviation);
                trend1[i] = trend1[i+1];  
                trend2[i] = trend2[i+1];
                trend3[i] = trend3[i+1];                     
                if (High[i]  > UpMa[i])                      trend1[i] =-1;
                if (Low[i]   < DnMa[i])                      trend1[i] = 1;
                if (Close[i] > UpMa[i])                      trend2[i] =-1;
                if (Close[i] < DnMa[i])                      trend2[i] = 1;
                if (Close[i] > UpMa[i] && Open[i] > UpMa[i]) trend3[i] =-1;
                if (Close[i] < DnMa[i] && Open[i] < DnMa[i]) trend3[i] = 1;
                
       }
   manageAlerts();         
   return(0);            
   }
   
   //
   //
   //
   //
   //
      
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         Ma[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsLength,BandsDeviation,AppliedPrice,BandsMaMode,0,y);
         UpMa[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsLength,BandsDeviation,AppliedPrice,BandsMaMode,1,y);
         DnMa[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsLength,BandsDeviation,AppliedPrice,BandsMaMode,2,y);
         trend1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsLength,BandsDeviation,AppliedPrice,BandsMaMode,3,y);
         trend2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsLength,BandsDeviation,AppliedPrice,BandsMaMode,4,y);
         trend3[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsLength,BandsDeviation,AppliedPrice,BandsMaMode,5,y);
    } 
manageAlerts();        
return(0);            
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar)); 

      //
      //
      //
      //
      //
            
      static datetime time1 = 0;
      static string   mess1 = "";
      if (alertsOnHiLoCross && trend1[whichBar] != trend1[whichBar+1])
      {
         if (trend1[whichBar] ==  1) doAlert(time1,mess1,whichBar,"Low price less than lower band");
         if (trend1[whichBar] == -1) doAlert(time1,mess1,whichBar,"High price greater than upper band ");
      }
      
      static datetime time2 = 0;
      static string   mess2 = "";
      if (alertsOnCloseCross && trend2[whichBar] != trend2[whichBar+1])
      {
         if (trend2[whichBar] ==  1) doAlert(time2,mess2,whichBar,"Close price less than lower band");
         if (trend2[whichBar] == -1) doAlert(time2,mess2,whichBar,"Close price greater than upper band");
      }
      
      static datetime time3 = 0;
      static string   mess3 = "";
      if (alertsOnOpenCloseCross && trend3[whichBar] != trend3[whichBar+1])
      {
         if (trend3[whichBar] ==  1) doAlert(time3,mess3,whichBar,"Open and Close price less than lower band");
         if (trend3[whichBar] == -1) doAlert(time3,mess3,whichBar,"Open and Close price greater than upper band");
      }
      
      
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Bollinger Bands ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Bollinger Bands " +" "+message));
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Bollinger Bands "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}
//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}   

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//


